unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, aes, base64, shellapi, ThemeMgr;

type
  TformMenuPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    opAlgoritmoAES: TRadioButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    txtClave: TEdit;
    mTextoCifrarDescifrar: TMemo;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    mTextoResultado: TMemo;
    bCopiarTextoCifrado: TBitBtn;
    bGuardarTextoResultado: TBitBtn;
    bCerrar: TBitBtn;
    Label14: TLabel;
    bGuardarTextoCD: TBitBtn;
    bCopiarTextoCifrar: TBitBtn;
    bCifrar: TBitBtn;
    bDescrifrar: TBitBtn;
    Label3: TLabel;
    dlGuardar: TSaveDialog;
    ThemeManager1: TThemeManager;
    procedure bCerrarClick(Sender: TObject);
    procedure bCopiarTextoCifradoClick(Sender: TObject);
    procedure Label14Click(Sender: TObject);
    procedure bCopiarTextoCifrarClick(Sender: TObject);
    procedure bCifrarClick(Sender: TObject);
    procedure bDescrifrarClick(Sender: TObject);
    procedure bGuardarTextoCDClick(Sender: TObject);
    procedure bGuardarTextoResultadoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

function cifrarTexto (Str, Clave : String) : String;
var
  Src: TStringStream;
  Dst: TMemoryStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TStringStream.Create(Str);
  try
    Dst:= TMemoryStream.Create;
    try
      // Preparamos la clave, lo ideal es que tenga 32 caracteres
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AEsExpandKey(ExpandedKey,Key);
      // Guardamos el tamao del texto original
      Size:= Src.Size;
      Dst.WriteBuffer(Size,Sizeof(Size));
      // Ciframos el texto
      AESEncryptStreamECB(Src,Dst,ExpandedKey);
      // Lo codificamos a base64
      Result:= BinToStr(Dst.Memory,Dst.Size);
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

function descifrarTexto (Str, Clave : String): String;
var
  Src: TMemoryStream;
  Dst: TStringStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TMemoryStream.Create;
  try
    Dst:= TStringStream.Create(Str);
    try
      StrToStream(Str,Src);
      Src.Position:= 0;
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AESExpandKey(ExpandedKey,Key);
      // Leemos el tamao del texto
      Src.ReadBuffer(Size,Sizeof(Size));
      AESDecryptStreamECB(Src,Dst,ExpandedKey);
      Dst.Size:= Size;
      Result:= Dst.DataString;
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.bCopiarTextoCifradoClick(Sender: TObject);
begin
  mTextoResultado.SelectAll;
  mTextoResultado.CopyToClipboard;
end;

procedure TformMenuPrincipal.Label14Click(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bCopiarTextoCifrarClick(Sender: TObject);
begin
  mTextoCifrarDescifrar.SelectAll;
  mTextoCifrarDescifrar.CopyToClipboard;
end;

procedure TformMenuPrincipal.bCifrarClick(Sender: TObject);
begin
  if txtClave.Text = '' then
  begin
    MessageDlg('Debe introducir la clave para la encriptacin, la misma ' +
        'que utilizar para desencriptar.', mtInformation, [mbok], 0);
    txtClave.SetFocus;
  end
  else
  begin
    if mTextoCifrarDescifrar.Text = '' then
    begin
      MessageDlg('Debe introducir el texto a cifrar.',
          mtInformation, [mbok], 0);
      mTextoCifrarDescifrar.SetFocus;
    end
    else
      mTextoResultado.Text := cifrarTexto (mTextoCifrarDescifrar.Text, txtClave.Text);
  end;
end;

procedure TformMenuPrincipal.bDescrifrarClick(Sender: TObject);
begin
  if txtClave.Text = '' then
  begin
    MessageDlg('Debe introducir la clave de desencriptacin, la misma ' +
        'que utiliz para encriptar.', mtInformation, [mbok], 0);
    txtClave.SetFocus;
  end
  else
  begin
    if mTextoCifrarDescifrar.Text = '' then
    begin
      MessageDlg('Debe introducir el texto a descifrar.',
          mtInformation, [mbok], 0);
      mTextoCifrarDescifrar.SetFocus;
    end
    else
      mTextoResultado.Text := descifrarTexto (mTextoCifrarDescifrar.Text,
          txtClave.Text);
  end;
end;

procedure TformMenuPrincipal.bGuardarTextoCDClick(Sender: TObject);
begin
  if dlGuardar.Execute then
    mTextoCifrarDescifrar.Lines.SaveToFile(dlGuardar.FileName);
end;

procedure TformMenuPrincipal.bGuardarTextoResultadoClick(Sender: TObject);
begin
  if dlGuardar.Execute then
    mTextoResultado.Lines.SaveToFile(dlGuardar.FileName);
end;

end.
